<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <router-link to="./release">
          <el-button type="primary" size="mini">发布成果</el-button>
        </router-link>
      </el-col>
    </el-row>

    <el-radio-group
      v-model="queryParams.status"
      size="mini"
      @change="handleQuery"
    >
      <el-radio-button :label="2">已发布</el-radio-button>
      <el-radio-button :label="1">待审核</el-radio-button>
      <el-radio-button :label="3">已驳回</el-radio-button>
      <el-radio-button :label="0">草稿箱</el-radio-button>
    </el-radio-group>

    <el-table v-loading="loading" :data="postList" style="margin-top: 20px">
      <el-table-column label="数据编号" prop="id" />
      <el-table-column label="成果名称" prop="title" />
      <el-table-column label="成果领域" prop="industrys" />
      <el-table-column label="浏览量" prop="visit_count" />
      <el-table-column label="发布时间" prop="created_at" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.created_at) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" class-name="small-padding fixed-width">
        <template #default="scope">
          <router-link
            :to="{ path: './release', query: { id: scope.row.id } }"
            v-if="queryParams.status == 0"
          >
            <el-button size="mini" type="text" icon="Edit">编辑</el-button>
          </router-link>

          <el-button
            v-if="queryParams.status == 2"
            size="mini"
            type="text"
            icon="Download"
            @click="handleShelf(scope.row)"
            >下架</el-button
          >
          <el-button
            v-if="queryParams.status != 1"
            size="mini"
            type="text"
            icon="Delete"
            @click="handleDelete(scope.row.id)"
            >删除</el-button
          >
          <el-button
            v-if="queryParams.status == 2"
            size="mini"
            type="text"
            icon="View"
            @click="handleResults(scope.row.id)"
            >查看匹配结果</el-button
          >
          <el-button
            v-if="queryParams.status == 1"
            size="mini"
            type="text"
            icon="Close"
            >取消发布</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script setup name="Post">
import {
  expertAchievement,
  achievementShelf,
  achievementDelete,
} from "@/api/admin/expert/technology";

const { proxy } = getCurrentInstance();
const router = useRouter();

const postList = ref([]);
const loading = ref(true);
const showSearch = ref(true);
const total = ref(0);
const dateRange = ref([]);

const data = reactive({
  form: {},
  queryParams: {
    page_num: 1,
    page_size: 10,
    status: 2,
  },
  rules: {
    name: [{ required: true, message: "公司名称不能为空", trigger: "blur" }],
    dutyParagraph: [
      { required: true, message: "公司税号不能为空", trigger: "blur" },
    ],
    bank: [{ required: true, message: "开户行不能为空", trigger: "blur" }],
    bankAccount: [
      { required: true, message: "开户行账号不能为空", trigger: "blur" },
    ],
    bankPhone: [
      { required: true, message: "开户行电话不能为空", trigger: "blur" },
    ],
    email: [{ required: true, message: "电子邮箱不能为空", trigger: "blur" }],
    phone: [{ required: true, message: "联系电话不能为空", trigger: "blur" }],
    address: [{ required: true, message: "地址不能为空", trigger: "blur" }],
    username: [{ required: true, message: "联系人不能为空", trigger: "blur" }],
    userPhone: [
      { required: true, message: "联系人电话不能为空", trigger: "blur" },
    ],
    userAddress: [
      { required: true, message: "邮寄地址不能为空", trigger: "blur" },
    ],
  },
});

const { queryParams, form, rules } = toRefs(data);

/** 查询列表 */
function getList() {
  loading.value = true;
  expertAchievement(queryParams.value).then((response) => {
    postList.value = response.data.data;
    total.value = response.data.count;
    loading.value = false;
  });
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}
/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}
/** 删除按钮操作 */
function handleDelete(id) {
  proxy.$modal
    .confirm('是否确认删除数据编号为"' + id + '"的成果项？')
    .then(function () {
      return achievementDelete({ id });
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}
function handleShelf(row) {
  let text = row.shelf_status == 2 ? "上架" : "下架";
  proxy.$modal
    .confirm('确认要"' + text + '""' + row.id + '"的成果吗?')
    .then(function () {
      let status = row.shelf_status == 1 ? 2 : 1;
      return achievementShelf({ id: row.id, status });
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess(text + "成功");
    })
    .catch(() => {});
}
function handleResults(id) {
  router.push({ path: "./results" });
}
getList();
</script>
